.include "m88PAdef.inc"

;	3:30:00		12600 	500
;	3:31:03		12663 	502,5		10,92	0,910
;	3:33:35		12815 	502,532		9,64	0,535

.DSEG
Timeout_high:	.byte	1
Timeout_low:	.byte	1
Counter_high:	.byte	1
Counter_low:	.byte	1
Time_syper_high:.byte	1
Time_high:		.byte	1
Time_low:		.byte	1
Time2000_high:	.byte	1
Time2000_low:	.byte	1
SECUNDS:		.byte	1
MINUTES:		.byte	1
HOURS:			.byte	1
Anim_high:		.byte	1
Anim_low:		.byte	1
Anim:			.byte	1

Do_r26:			.byte	1
Do_r27:			.byte	1
Do_r28:			.byte	1
Do_r29:			.byte	1
Now_r26:		.byte	1
Now_r27:		.byte	1
Now_r28:		.byte	1
Now_r29:		.byte	1
RAID36:			.byte	72
MetkaRAID:		.byte	1

Alfa_Low:		.byte	1
Alfa_High:		.byte	1
Alfa_syper_High:.byte	1
Beta_Low:		.byte	1
Beta_High:		.byte	1
Beta_syper_High:.byte	1
Gama_Low:		.byte	1
Gama_High:		.byte	1
Gama_syper_High:.byte	1

Battery_Low:	.byte	1
Battery_High:	.byte	1


.CSEG
.ORG $0000
	rjmp	reset

.ORG $0001		; INT0 External Interrupt Request 1
	rjmp	INT_Shelchok

.ORG $0002		; INT1 External Interrupt Request 1
	rjmp	INT_Shelchok

.ORG $0003		; PCINT0 Handler
	ret

.ORG $0004		; PCINT1 Handler
	ret

.ORG $0018		; TIM1_COMPB Timer/Counter1 Compare Match B
	rjmp	Dergati_IRF840

INT_Shelchok:
	set							;   T
	in		r3, SREG
	adiw	r26, 1
	breq	adiw_high_bytes
	out		SREG, r3
	reti
adiw_high_bytes:
	adiw	r28, 1
	out		SREG, r3
	reti

;---------------------------------------------------------------

Dergati_IRF840:
	push	r23
	push	r24
	push	r25
	in		r23, SREG

	lds		r24, Counter_low
	lds		r25, Counter_high

	sbic 	PIND, PIND0			; ,   COP 
	rjmp	zakritie_IRF840

	sbiw	r24, 1
	brne	end_IRF840

	sbi		PORTC,DDC5			;  DIOD
	rcall	pause_10mksec
	rcall	pause_10mksec
	sbi		PORTD,DDD0			;  COP
	lds		r24, Timeout_low
	lds		r25, Timeout_high
	rjmp	end_IRF840
zakritie_IRF840:
;	ori		r23, 0b01000000		;   
	cbi		PORTC,DDC5			;   DIOD
	cbi		PORTD,DDD0			;   COP
	sbi		PORTD,DDD1			;  VT
	rcall	pause_10mksec
	rcall	pause_10mksec
	sbic 	PIND, PIND6			; ,   OOC 
	rjmp	ne_delenie_K_na_2
	cpi		r24, 20
	cpc		r25, r0
	brlo	delenie_K_na_2
	lsr		r25
	ror		r24
	rjmp	delenie_K_na_2
ne_delenie_K_na_2:
	sbrc	r25, 3
	rjmp	delenie_K_na_2
	lsl		r24
	rol		r25
delenie_K_na_2:
	sts		Timeout_low, r24
	sts		Timeout_high, r25
	cbi		PORTD,DDD1			;   VT
end_IRF840:
	sts		Counter_low, r24
	sts		Counter_high, r25

	lds		r24, Time2000_low
	lds		r25, Time2000_high
	sbiw	r24, 1
	breq	plus_1sec
	rjmp	ne_plus_1sec
plus_1sec:

	ldi		r24, 0b11000000
	or		r1, r24

	lds		r24, Now_r26
	lds		r25, Now_r27
	sts		Do_r26, r24
	sts		Do_r27, r25
	lds		r24, Now_r28
	lds		r25, Now_r29
	sts		Do_r28, r24
	sts		Do_r29, r25
	sts		Now_r26, r26
	sts		Now_r27, r27
	sts		Now_r28, r28
	sts		Now_r29, r29

	lds		r24, SECUNDS
	inc		r24
	cpi		r24, 60
	brlo	ne_sbros_sec
	clr		r24
	sts		SECUNDS, r24
	lds		r24, MINUTES
	inc		r24
	cpi		r24, 60
	brlo	ne_sbros_min
	clr		r24
	sts		MINUTES, r24
	lds		r24, HOURS
	inc		r24
	cpi		r24, 100
	brlo	ne_sbros_hour
	ldi		r24, 0b00000100
	mov		r1, r24
	ldi		r24, 59
	sts		SECUNDS, r24
	sts		MINUTES, r24
	ldi		r24, 99
ne_sbros_hour:
	sts		HOURS, r24
	rjmp	prig_sbros
ne_sbros_min:
	sts		MINUTES, r24
	rjmp	prig_sbros
ne_sbros_sec:
	sts		SECUNDS, r24
prig_sbros:

	lds		r24, Time_low
	lds		r25, Time_high
	adiw	r24, 1
	brne	ne_adiw_high_byte
	sts		Time_low, r24
	sts		Time_high, r25
	lds		r24, Time_syper_high
	inc		r24
	sts		Time_syper_high, r24
	rjmp	adiw_high_byte
ne_adiw_high_byte:
	sts		Time_low, r24
	sts		Time_high, r25
adiw_high_byte:
	ldi		r24, low(2000)
	ldi		r25, high(2000)
ne_plus_1sec:
	sts		Time2000_low, r24
	sts		Time2000_high, r25

	brbc	6, ne_Shelchok
	sbic 	PINB, PINB7
	rjmp	pisk_inv
	sbi		PORTB,DDB7			;  PISK1
	cbi		PORTB,DDB6			;   PISK2
	rjmp	pisk_no_inv
pisk_inv:
	sbi		PORTB,DDB6			;  PISK2
	cbi		PORTB,DDB7			;   PISK1
pisk_no_inv:
	ldi		r24, 0b10000000
	or		r1, r24
	andi	r23, 0b10111111		;   
ne_Shelchok:

	lds		r24, Anim_low
	lds		r25, Anim_high

	sbiw	r24, 1
	brne	ne_time_Anim
	ldi		r24, low(500)
	ldi		r25, high(500)
	sts		Anim_low, r24
	sts		Anim_high, r25
	ldi		r24, 0b00100000
	or		r1, r24
	rjmp	prig_Anim
ne_time_Anim:
	sts		Anim_low, r24
	sts		Anim_high, r25
prig_Anim:

	out		SREG, r23
	pop		r25
	pop		r24
	pop		r23
	reti

pause_10mksec:
	nop
	nop
	nop
	ret

;------------------------------------------

reset:
	ldi		r24, low(RAMEND)
	out		SPL, r24
	ldi		r24, high(RAMEND)
	out		SPH, r24

	ldi		r24, 0b10000000
	ldi		r25, 0b00000011		; Clock Division Factor = 8	F = 1 MHz
	sts		CLKPR, r24
	sts		CLKPR, r25

	clr		r0					;  
	ldi		r24, 0b11001000
	mov		r1, r24				; 

;	r26, r27, r28, r29  r3 - ,   !

;-------------------- ----------------------

	sbi		DDRC, DDC4			;  ZARIAD
	cbi		PORTC,DDC4			;   ZARIAD
	sbi		DDRC, DDC5			;  DIOD
	sbi		DDRD, DDD0			;  COP
	sbi		DDRD, DDD1			;  VT
;	sbi		PORTC,DDC5			;  DIOD
;	cbi		PORTC,DDC5			;   DIOD
;	sbi		PORTD,DDD0			;  COP
;	cbi		PORTD,DDD0			;   COP
;	sbi		PORTD,DDD1			;  VT
;	cbi		PORTD,DDD1			;   VT

	sbi		DDRB, DDB7			;  PISK1
	sbi		DDRB, DDB6			;  PISK2
;	sbi		PORTB,DDB7			;  PISK1
;	sbi		PORTB,DDB6			;  PISK2
;	cbi		PORTB,DDB7			;   PISK1
;	cbi		PORTB,DDB6			;   PISK2

	sbi		DDRD, DDD5			;  RES
	sbi		DDRD, DDD7			;  D/C
	sbi		DDRB, DDB5			;  CLK
	sbi		DDRB, DDB3			;  DO
	sbi		DDRB, DDB2			;  
;	sbi		PORTD,DDD7			;  D/C DATA
;	cbi		PORTD,DDD7			;   D/C CMD

;-------------------------- --------------------------------

	rcall	Global_Obnulenie

	ldi		r24, low(2560)
	ldi		r25, high(2560)
	rcall	Timeout_zapis

	rcall	SPI_init
	rcall	LCD_init
	rcall	timer_init
	rcall	INT_init
	sei

;----------------------------------------------------

;	rcall	Battery_mer
	ldi		r18, 7
	rcall	shym
	ldi		r18, 3
	rcall	ZASTAVKA
	ldi		r18, 3
	rcall	shym
	ldi		r18, 20
	rcall	ZASTAVKA
	ldi		r18, 1
	rcall	shym
	ldi		r18, 20
	rcall	ZASTAVKA
	ldi		r18, 2
	rcall	shym
	ldi		r18, 3
	rcall	ZASTAVKA
	ldi		r18, 5
	rcall	shym
	ldi		r18, 3
	rcall	ZASTAVKA
	ldi		r18, 5
	rcall	shym

start_nachalo:
	rcall	Zabelenie
	sbic 	PINB, PINB4			; 
	rjmp	Zaryadka
	ldi		r30, low(Batter*2)
	ldi		r31, high(Batter*2)
	ldi		r19, 0
	ldi		r20, 0
	rcall	IMAGE
	ldi		r30, low(CPS*2)
	ldi		r31, high(CPS*2)
	ldi		r19, 81
	ldi		r20, 4
	rcall	IMAGE
	ldi		r30, low(MkrH*2)
	ldi		r31, high(MkrH*2)
	ldi		r19, 71
	ldi		r20, 7
	rcall	IMAGE
	ldi		r30, low(RAD_0*2)
	ldi		r31, high(RAD_0*2)
	ldi		r19, 0				; X
	ldi		r20, 2				; Y
	rcall	IMAGE
	ldi		r30, low(PLAV*2)
	ldi		r31, high(PLAV*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
;	ldi		r16, 10
;	rcall	Battery

;---------------------------!-------------------------

here:

	sbic 	PINB, PINB4			; 
	rjmp	Zaryadka

	sbrs	r1, 5
	rjmp	ne_obnovlenie_Anim
	ldi		r24, 0b11011111
	and		r1, r24

	lds		r24, Anim
	sbrc	r1, 4
	rjmp	veseliy_rodger

	cpi		r24, 0
	brne	ne_RAD_0
ne_RAD_3:
	ldi		r30, low(RAD_0*2)
	ldi		r31, high(RAD_0*2)
	ldi		r24, 1
	rjmp	go_Anim
ne_RAD_0:
	cpi		r24, 1
	brne	ne_RAD_1
	ldi		r30, low(RAD_1*2)
	ldi		r31, high(RAD_1*2)
	ldi		r24, 2
	rjmp	go_Anim
ne_RAD_1:
	cpi		r24, 2
	brne	ne_RAD_2
	ldi		r30, low(RAD_2*2)
	ldi		r31, high(RAD_2*2)
	ldi		r24, 3
	rjmp	go_Anim
ne_RAD_2:
	cpi		r24, 3
	brne	ne_RAD_3
	ldi		r30, low(RAD_3*2)
	ldi		r31, high(RAD_3*2)
	ldi		r24, 0
	rjmp	go_Anim

veseliy_rodger:

	cpi		r24, 0
	brne	ne_RODGER
ne_RODGER_inv:
	ldi		r30, low(RODGER*2)
	ldi		r31, high(RODGER*2)
	ldi		r24, 1
	rjmp	go_Anim
ne_RODGER:
	cpi		r24, 1
	brne	ne_RODGER_inv
	ldi		r30, low(RODGER_inv*2)
	ldi		r31, high(RODGER_inv*2)
	ldi		r24, 0
;	rjmp	go_Anim

go_Anim:
	sts		Anim, r24
	ldi		r19, 0				; X
	ldi		r20, 2				; Y
	rcall	IMAGE

ne_obnovlenie_Anim:

	sbrs	r1, 6
	rjmp	ne_obnovlenie_time
	ldi		r24, 0b10111111
	and		r1, r24

	sbrc	r1, 2
	rjmp	ne_Regim_Nakopleniy

	sbrs	r1, 3
	rjmp	Regim_Nakopleniy

	cli
	lds		r16, Now_r26
	lds		r17, Now_r27
	lds		r18, Now_r28
	lds		r19, Now_r29
	lds		r20, Do_r26
	lds		r21, Do_r27
	lds		r22, Do_r28
	lds		r23, Do_r29
	sei
	sub		r16, r20
	sbc		r17, r21
	sbc		r18, r22
	sbc		r19, r23

	lds		r24, MetkaRAID
	inc		r24
	cpi		r24, 36
	brlo	ne_sbros_metki
	ldi		r24, 0
ne_sbros_metki:
	sts		MetkaRAID, r24
	lsl		r24
	ldi		r30, low(RAID36)
	ldi		r31, high(RAID36)
	add		r30, r24
	adc		r31, r0
	st		Z+, r16
	st		Z+, r17

	clr		r8
	clr		r9
	clr		r10
	clr		r11
	ldi		r23, 36
	ldi		r24, 0
cikl_usredneniy:
	inc		r24
	ld		r17, -Z
	ld		r16, -Z
	add		r8, r16
	adc		r9, r17
	adc		r10, r0
	ldi		r16, 40
	cp		r8, r16
	cpc		r9, r0
	cpc		r10, r0
	brsh	bolshe_40cp
	cpi		r30, low(RAID36)
	ldi		r16, high(RAID36)
	cpc		r31, r16
	brsh	ne_sbros_RAID
	ldi		r30, low(RAID36+72)
	ldi		r31, high(RAID36+72)
ne_sbros_RAID:
	dec		r23
	brne	cikl_usredneniy
bolshe_40cp:
	push	r24
	ldi		r24, low(1800)
	ldi		r25, high(1800)
	mov		r12, r24
	mov		r13, r25
	clr		r14
	clr		r15
;	r8 - Low1	1 / 
;	r9 - Low2	1 / 
;	r10 - High1	1 / 
;	r11 - High2	1 / 
;	r12 - Low1	2 / 
;	r13 - Low2	2 / 
;	r14 - High1	2 / 
;	r15 - High2	2 / 
	rcall	ymnogenie
	pop		r4
	clr		r5
	clr		r6
	clr		r7
;	r4 - Low1	
;	r5 - Low2	
;	r6 - High1	
;	r7 - High2	
;	r8 - Low1	 / 
;	r9 - Low2	 / 
;	r10 - High1	 / 
;	r11 - High2	 / 
;	r12 - Low3	 / 
;	r13 - Low4	 / 
;	r14 - High3	 / 
;	r15 - High4	 / 
	rcall	delenie
	mov		r16, r8
	mov		r17, r9
	mov		r18, r10

	rcall	Proverka_vihoda_za_3byta

	rcall	proveka_Poroga

;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 
	ldi		r19, 10				; X
	ldi		r20, 6				; Y
	ldi		r21, 5				; 
	rcall	chislo_XXXXXXX

	ldi		r24, low(10)
	ldi		r25, high(10)
	mov		r12, r24
	mov		r13, r25
	clr		r14
	clr		r15
;	r8 - Low1	1 / 
;	r9 - Low2	1 / 
;	r10 - High1	1 / 
;	r11 - High2	1 / 
;	r12 - Low1	2 / 
;	r13 - Low2	2 / 
;	r14 - High1	2 / 
;	r15 - High2	2 / 
	rcall	ymnogenie
	ldi		r24, 18
	mov		r4, r24
	clr		r5
	clr		r6
	clr		r7
;	r4 - Low1	
;	r5 - Low2	
;	r6 - High1	
;	r7 - High2	
;	r8 - Low1	 / 
;	r9 - Low2	 / 
;	r10 - High1	 / 
;	r11 - High2	 / 
;	r12 - Low3	 / 
;	r13 - Low4	 / 
;	r14 - High3	 / 
;	r15 - High4	 / 
	rcall	delenie
	mov		r16, r8
	mov		r17, r9
	mov		r18, r10
;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 
	ldi		r19, 20				; X
	ldi		r20, 3				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX
	rjmp	ne_Regim_Nakopleniy

Regim_Nakopleniy:

	rcall	HourMinSec_mer

ne_Regim_Nakopleniy:

	rcall	Battery_mer

ne_obnovlenie_time:

	sbrc	r1, 2
	rjmp	ne_obnovlenie_CPS_mkR

	sbrs	r1, 7
	rjmp	ne_obnovlenie_CPS_mkR
	ldi		r24, 0b01111111
	and		r1, r24

	sbrc	r1, 3
	rjmp	ne_obnovlenie_CPS_mkR

	ldi		r21, 0x40
	ldi		r22, 0x42
	ldi		r23, 0x0F
	rcall	Podschet_CPX
;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 
	ldi		r19, 20				; X
	ldi		r20, 3				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX

	ldi		r21, 0x40
	ldi		r22, 0x77
	ldi		r23, 0x1B
	rcall	Podschet_CPX

	rcall	Proverka_vihoda_za_3byta

	rcall	proveka_Poroga
;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 
	ldi		r19, 10				; X
	ldi		r20, 6				; Y
	ldi		r21, 5				; 
	rcall	chislo_XXXXXXX

ne_obnovlenie_CPS_mkR:


	sbic 	PINC, PINC3			;  2
	rjmp	knopka_2_ne_nagata
knopka_2_nagata:
	ldi		r23, 10
	rcall	pause
	sbis 	PINC, PINC3
	rjmp	knopka_2_nagata
	ldi		r23, 10
	rcall	pause

	sbrs	r1, 2
	rjmp	perekl_na_STOP2
	ldi		r24, 0b11111011
	and		r1, r24
	ldi		r30, low(PLAV*2)
	ldi		r31, high(PLAV*2)
	sbrs	r1, 3
	ldi		r30, low(SUMMA*2)
	sbrs	r1, 3
	ldi		r31, high(SUMMA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
	rcall	Global_Obnulenie
	rjmp	knopka_1_ne_nagata

perekl_na_STOP2:
	ldi		r24, 0b00000100
	or		r1, r24
	ldi		r30, low(PAUSA*2)
	ldi		r31, high(PAUSA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE

knopka_2_ne_nagata:


	sbic 	PINC, PINC2			;  1
	rjmp	knopka_1_ne_nagata
	ldi		r24, 11
knopka_1_nagata:
	dec		r24
	breq	GO_Sleep
	ldi		r23, 10
	rcall	pause
	sbis 	PINC, PINC2
	rjmp	knopka_1_nagata
	ldi		r23, 10
	rcall	pause

	rcall	Global_Obnulenie

	sbrc	r1, 3
	rjmp	perekl_na_regim_Nakopleniy
	sbrs	r1, 1
	rjmp	Alfaizmerenie
	ldi		r24, 0b11001000
	mov		r1, r24
	ldi		r30, low(PLAV*2)
	ldi		r31, high(PLAV*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
	rjmp	knopka_1_ne_nagata
perekl_na_regim_Nakopleniy:
	ldi		r24, 0b11000000
	mov		r1, r24
	ldi		r30, low(SUMMA*2)
	ldi		r31, high(SUMMA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
	rjmp	knopka_1_ne_nagata

GO_Sleep:
	sts		TCCR1B, r0
	sts		TIMSK1, r0
	sts		EICRA, r0
	out		EIMSK, r0
	cbi		PORTB,DDB6			;   PISK2
	cbi		PORTB,DDB7			;   PISK1
	cbi		PORTC,DDC5			;   DIOD
	cbi		PORTD,DDD0			;   COP
	sbi		PORTD,DDD1			;  VT
	rcall	pause_10mksec
	rcall	pause_10mksec
	rcall	pause_10mksec
	cbi		PORTD,DDD1			;   VT
	ldi		r24, 0b00100101
	rcall	SPI_Write_CMD

knopka_1_nagata_sleep:
	ldi		r23, 10
	rcall	pause
	sbis 	PINC, PINC2
	rjmp	knopka_1_nagata_sleep
	ldi		r23, 20
	rcall	pause

	ldi		r24, 0b00000101		; Sleep Enable / Power-down
	out		SMCR, r24
	ldi		r24, 0b00000011		; PCIE1..0 PCINT14..0
	sts		PCICR, r24
	ldi		r24, 0b00000100		; PCINT10 Pin Change Enable Mask
	sts		PCMSK1, r24
	ldi		r24, 0b00010000		; PCINT4 Pin Change Enable Mask
	sts		PCMSK0, r24
	sleep
	nop
	out		SMCR, r0
	sts		PCICR, r0
	sts		PCMSK1, r0
	sts		PCMSK0, r0
	rjmp	reset

knopka_1_ne_nagata:

	rjmp	here



Alfaizmerenie:
	rcall	Zabelenie
	ldi		r30, low(Batter*2)
	ldi		r31, high(Batter*2)
	ldi		r19, 0
	ldi		r20, 0
	rcall	IMAGE
	ldi		r30, low(CPS*2)
	ldi		r31, high(CPS*2)
	ldi		r19, 82
	ldi		r20, 3
	rcall	IMAGE
	ldi		r30, low(Summa_ravno*2)
	ldi		r31, high(Summa_ravno*2)
	ldi		r19, 0
	ldi		r20, 2
	rcall	IMAGE
	ldi		r30, low(SUMMA*2)
	ldi		r31, high(SUMMA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE

	ldi		r24, 0b11010000
	mov		r1, r24

shere:

	sbic 	PINB, PINB4			; 
	rjmp	Zaryadka

	sbrs	r1, 6
	rjmp	ne_obnovlenie_time_Alfa
	ldi		r24, 0b10111111
	and		r1, r24

	rcall	Battery_mer

	sbrc	r1, 1
	rjmp	ne_obnovlenie_time_Alfa

	rcall	HourMinSec_mer

ne_obnovlenie_time_Alfa:

	sbrc	r1, 1
	rjmp	ne_obnovlenie_CPS_mkR_Alfa

	sbrs	r1, 7
	rjmp	ne_obnovlenie_CPS_mkR_Alfa
	ldi		r24, 0b01111111
	and		r1, r24

	ldi		r21, 0x40
	ldi		r22, 0x42
	ldi		r23, 0x0F
	rcall	Podschet_CPX
;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 

	sbrs	r1, 4
	rjmp	ne_etap_1

	sts		Alfa_Low, r16
	sts		Alfa_High, r17
	sts		Alfa_syper_High, r18
	ldi		r19, 20				; X
	ldi		r20, 2				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX
	rjmp	ne_obnovlenie_CPS_mkR_Alfa

ne_etap_1:

	sbrs	r1, 3
	rjmp	ne_etap_2

	sts		Beta_Low, r16
	sts		Beta_High, r17
	sts		Beta_syper_High, r18
	ldi		r19, 20				; X
	ldi		r20, 4				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX
	lds		r16, Alfa_Low
	lds		r17, Alfa_High
	lds		r18, Alfa_syper_High
	lds		r19, Beta_Low
	lds		r20, Beta_High
	lds		r21, Beta_syper_High
	sub		r16, r19
	sbc		r17, r20
	sbc		r18, r21
	brsh	ne_fatal_menshe
	clr		r16
	clr		r17
	clr		r18
ne_fatal_menshe:
	ldi		r19, 20				; X
	ldi		r20, 2				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX
	rjmp	ne_obnovlenie_CPS_mkR_Alfa

ne_etap_2:

	sts		Gama_Low, r16
	sts		Gama_High, r17
	sts		Gama_syper_High, r18
	ldi		r19, 20				; X
	ldi		r20, 6				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX
	lds		r16, Beta_Low
	lds		r17, Beta_High
	lds		r18, Beta_syper_High
	lds		r19, Gama_Low
	lds		r20, Gama_High
	lds		r21, Gama_syper_High
	sub		r16, r19
	sbc		r17, r20
	sbc		r18, r21
	brsh	ne_fatal_menshe_2
	clr		r16
	clr		r17
	clr		r18
ne_fatal_menshe_2:
	ldi		r19, 20				; X
	ldi		r20, 4				; Y
	ldi		r21, 4				; 
	rcall	chislo_XXXXXXX

ne_obnovlenie_CPS_mkR_Alfa:

	sbic 	PINC, PINC2			;  1
	rjmp	knopka_1_ne_nagata_Alfa
	ldi		r24, 11
knopka_1_nagata_Alfa:
	dec		r24
	brne	ne_GO_Sleep
	rjmp	GO_Sleep
ne_GO_Sleep:
	ldi		r23, 10
	rcall	pause
	sbis 	PINC, PINC2
	rjmp	knopka_1_nagata_Alfa
	ldi		r23, 10
	rcall	pause
	ldi		r24, 0b11001000
	mov		r1, r24
	rcall	Global_Obnulenie
	rjmp	start_nachalo

knopka_1_ne_nagata_Alfa:

	sbic 	PINC, PINC3			;  2
	rjmp	knopka_2_ne_nagata_Alfa
knopka_2_nagata_Alfa:
	ldi		r23, 10
	rcall	pause
	sbis 	PINC, PINC3
	rjmp	knopka_2_nagata_Alfa
	ldi		r23, 10
	rcall	pause

	sbrs	r1, 1
	rjmp	ne_na_PAUSE
	ldi		r24, 0b11111101
	and		r1, r24

	ldi		r30, low(SUMMA*2)
	ldi		r31, high(SUMMA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
	rjmp	menyem_regim

ne_na_PAUSE:

	sbrs	r1, 2
	rjmp	na_PAUSE
	ldi		r24, 0b00000010
	or		r1, r24

	ldi		r30, low(Result*2)
	ldi		r31, high(Result*2)
	ldi		r19, 23
	ldi		r20, 0
	rcall	IMAGE
	rjmp	knopka_2_ne_nagata_Alfa

na_PAUSE:
	ldi		r24, 0b00000010
	or		r1, r24

	ldi		r30, low(PAUSA*2)
	ldi		r31, high(PAUSA*2)
	ldi		r19, 82
	ldi		r20, 0
	rcall	IMAGE
	rjmp	knopka_2_ne_nagata_Alfa
menyem_regim:

	rcall	Global_Obnulenie

	sbrs	r1, 4
	rjmp	ne_poschet_Alfa
	ldi		r24, 0b11001000
	mov		r1, r24

	ldi		r30, low(CPS*2)
	ldi		r31, high(CPS*2)
	ldi		r19, 82
	ldi		r20, 5
	rcall	IMAGE
	ldi		r30, low(Alfa*2)
	ldi		r31, high(Alfa*2)
	ldi		r19, 0
	ldi		r20, 2
	rcall	IMAGE
	ldi		r30, low(Summa_ravno*2)
	ldi		r31, high(Summa_ravno*2)
	ldi		r19, 0
	ldi		r20, 4
	rcall	IMAGE

	rjmp	knopka_2_ne_nagata_Alfa

ne_poschet_Alfa:

	sbrs	r1, 3
	rjmp	Alfaizmerenie
	ldi		r24, 0b11000100
	mov		r1, r24

	ldi		r30, low(CPS*2)
	ldi		r31, high(CPS*2)
	ldi		r19, 82
	ldi		r20, 7
	rcall	IMAGE
	ldi		r30, low(Beta*2)
	ldi		r31, high(Beta*2)
	ldi		r19, 0
	ldi		r20, 4
	rcall	IMAGE
	ldi		r30, low(Gamma*2)
	ldi		r31, high(Gamma*2)
	ldi		r19, 0
	ldi		r20, 6
	rcall	IMAGE

knopka_2_ne_nagata_Alfa:

	rjmp	shere

;-----------------------------------------------------------

Zaryadka:
	ldi		r23, 20
	rcall	pause

	sbi		PORTC,DDC4			;  ZARIAD
	cbi		DDRB, DDB7			;  PISK1
	cbi		DDRB, DDB6			;  PISK2
	rcall	Global_Obnulenie
	rcall	Zabelenie
	ldi		r30, low(Batter*2)
	ldi		r31, high(Batter*2)
	ldi		r19, 0
	ldi		r20, 0
	rcall	IMAGE

;	ldi		r16, 10
;	rcall	Battery

	ldi		r24, 0b01000000
	mov		r1, r24

Zaryad:
	sbis 	PINB, PINB4			; 
	rjmp	Zaryad_end
	sbrs	r1, 6
	rjmp	Zaryad
	ldi		r24, 0b10111111
	and		r1, r24

	ldi		r24, low(40960)
	ldi		r25, high(40960)
	rcall	Timeout_zapis

	rcall	Battery_mer
	rcall	HourMinSec_mer

	lds		r22, Battery_Low
	lds		r23, Battery_High
	ldi		r24, low(421)
	ldi		r25, high(421)
	cp		r22, r24
	cpc		r23, r25
	brlo	Zaryad

Zaryad_end:
	ldi		r23, 20
	rcall	pause
	cbi		PORTC,DDC4			;   ZARIAD
	sbi		DDRB, DDB7			;  PISK1
	sbi		DDRB, DDB6			;  PISK2

	rjmp	GO_Sleep

;-----------------------------------------------------------

Proverka_vihoda_za_3byta:
	cp		r11, r0
	breq	ne_vihod_za_3byta
	ldi		r16, 0xFF
	ldi		r17, 0xFF
	ldi		r18, 0xFF
ne_vihod_za_3byta:
	ret

Podschet_CPX:
	cli
	push	r26
	push	r27
	push	r28
	push	r29
	lds		r24, Time2000_low
	lds		r25, Time2000_high
	push	r24
	push	r25
	lds		r12, Time_low
	lds		r13, Time_high
	lds		r14, Time_syper_high
	sei
	ldi		r24, low(1000)
	ldi		r25, high(1000)
	mov		r8, r24
	mov		r9, r25
	clr		r10
	clr		r11
	clr		r15
;	r8 - Low1	1 / 
;	r9 - Low2	1 / 
;	r10 - High1	1 / 
;	r11 - High2	1 / 
;	r12 - Low1	2 / 
;	r13 - Low2	2 / 
;	r14 - High1	2 / 
;	r15 - High2	2 / 
	rcall	ymnogenie
	ldi		r24, low(1000)
	ldi		r25, high(1000)
	mov		r4, r24
	mov		r5, r25
	pop		r25
	pop		r24
	lsr		r25
	ror		r24
	sub		r4, r24
	sbc		r5, r25
	sbc		r6, r0
	sbc		r7, r0
	add		r4, r8
	adc		r5, r9
	adc		r6, r10
	adc		r7, r11
	pop		r11
	pop		r10
	pop		r9
	pop		r8
	mov		r12, r21
	mov		r13, r22
	mov		r14, r23
	clr		r15
;	r8 - Low1	1 / 
;	r9 - Low2	1 / 
;	r10 - High1	1 / 
;	r11 - High2	1 / 
;	r12 - Low1	2 / 
;	r13 - Low2	2 / 
;	r14 - High1	2 / 
;	r15 - High2	2 / 
	rcall	ymnogenie
;	r4 - Low1	
;	r5 - Low2	
;	r6 - High1	
;	r7 - High2	
;	r8 - Low1	 / 
;	r9 - Low2	 / 
;	r10 - High1	 / 
;	r11 - High2	 / 
;	r12 - Low3	 / 
;	r13 - Low4	 / 
;	r14 - High3	 / 
;	r15 - High4	 / 
	rcall	delenie
	mov		r16, r8
	mov		r17, r9
	mov		r18, r10
	ret

Battery_mer:
	rcall	ADC7_start
	rcall	opros_ADIF1

	ldi		r23, 1
	rcall	pause
	rcall	ADC7_start
	rcall	opros_ADIF1
	lds		r10, ADCL
	lds		r11, ADCH
	rcall	ADC7_stop
	clr		r8
	clr		r9
	clr		r12
	clr		r13
	clr		r14
	clr		r15
	ldi		r24, 0x7D
	mov		r4, r24
	ldi		r24, 0xC3
	mov		r5, r24
	ldi		r24, 0x01
	mov		r6, r24
	clr		r7
;	r4 - Low1	
;	r5 - Low2	
;	r6 - High1	
;	r7 - High2	
;	r8 - Low1	 / 
;	r9 - Low2	 / 
;	r10 - High1	 / 
;	r11 - High2	 / 
;	r12 - Low3	 / 
;	r13 - Low4	 / 
;	r14 - High3	 / 
;	r15 - High4	 / 
	rcall	delenie
	sts		Battery_Low, r8
	sts		Battery_High, r9
	mov		r16, r8
	mov		r17, r9
	ldi		r19, 0
	ldi		r20, 1
;	r16 - Low 
;	r17 - High 
;	r19 - X
;	r20 - Y
	rcall	chislo_XXX

	mov		r17, r8
	mov		r18, r9
	ldi		r24, high(340)
	cpi		r17, low(340)
	cpc		r18, r24
	brsh	ne_menshe_330
	ldi		r24, high(260)
	cpi		r17, low(260)
	cpc		r18, r24
	brsh	ne_menshe_250
	sbic 	PINB, PINB4			; 
	rjmp	ne_otkl
	ldi		r24, high(245)
	cpi		r17, low(245)
	cpc		r18, r24
	brsh	ne_otkl
	rjmp	GO_Sleep
ne_otkl:
	ldi		r24,0b00100001		; H=1
	rcall	SPI_Write_CMD
	ldi		r24,0b00001011		; 5x voltage multiplier
	rcall	SPI_Write_CMD
	ldi		r24,0b00100000		; H=0
	rcall	SPI_Write_CMD
	rjmp	bolshe_330
ne_menshe_250:
	ldi		r24,0b00100001		; H=1
	rcall	SPI_Write_CMD
	ldi		r24,0b00001010		; 4x voltage multiplier
	rcall	SPI_Write_CMD
	ldi		r24,0b00100000		; H=0
	rcall	SPI_Write_CMD
	rjmp	bolshe_330
ne_menshe_330:
	ldi		r24,0b00100001		; H=1
	rcall	SPI_Write_CMD
	ldi		r24,0b00001001		; 3x voltage multiplier
	rcall	SPI_Write_CMD
	ldi		r24,0b00100000		; H=0
	rcall	SPI_Write_CMD
bolshe_330:
	subi	r17, 230
	sbc		r18, r0
	brsh	ne_menshe_230
	clr		r17
	clr		r18
ne_menshe_230:
	ldi		r16, 21
nabiraem_K:
	dec		r16
	cpi		r16, 1
	breq	hvatit_k
	subi	r17, 10
	sbc		r18, r0
	brsh	nabiraem_K
hvatit_k:
;	r16 -    1  19
	rcall	Battery
	ret


HourMinSec_mer:
	lds		r16, HOURS
	ldi		r19, 26				; X
	ldi		r20, 0				; Y
;	r16 - 
;	r19 - X
;	r20 - Y
	rcall	chislo_XX

	lds		r16, MINUTES
	ldi		r19, 46				; X
	ldi		r20, 0				; Y
;	r16 - 
;	r19 - X
;	r20 - Y
	rcall	chislo_XX

	lds		r16, SECUNDS
	ldi		r19, 66				; X
	ldi		r20, 0				; Y
;	r16 - 
;	r19 - X
;	r20 - Y
	rcall	chislo_XX
	ret


Timeout_zapis:
	cli
	sts		Timeout_low, r24
	sts		Timeout_high, r25
	sts		Counter_low, r24
	sts		Counter_high, r25
	sei
	ret

proveka_Poroga:
	ldi		r24, low(5000)		; > 50.00 / ->   
	ldi		r25, high(5000)		; < 50.00 / ->   
	cp		r16, r24
	cpc		r17, r25
	cpc		r18, r0
	brsh	porog_srabotal
	ldi		r24, 0b11101111
	and		r1, r24
	rjmp	porog_ne_srabotal
porog_srabotal:
	ldi		r24, 0b00010000
	or		r1, r24
porog_ne_srabotal:
	ret

;--------------- ------------------------

;	r8 - Low1	1 / 
;	r9 - Low2	1 / 
;	r10 - High1	1 / 
;	r11 - High2	1 / 

;	r12 - Low1	2 / 
;	r13 - Low2	2 / 
;	r14 - High1	2 / 
;	r15 - High2	2 / 

ymnogenie:
	push	r4
	push	r5
	push	r6
	push	r7
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	r23
	push	r24
	mov		r16, r8
	mov		r17, r9
	mov		r18, r10
	mov		r19, r11
	ldi		r20, 0
	ldi		r21, 0
	ldi		r22, 0
	ldi		r23, 0
	mov		r4, r12
	mov		r5, r13
	mov		r6, r14
	mov		r7, r15
	ldi		r24, 0
	mov		r8, r24
	mov		r9, r24
	mov		r10, r24
	mov		r11, r24
	mov		r12, r24
	mov		r13, r24
	mov		r14, r24
	mov		r15, r24
	ldi		r24, 32
	rjmp	prigok2
mul_cikl:
	lsl		r16
	rol		r17
	rol		r18
	rol		r19
	rol		r20
	rol		r21
	rol		r22
	rol		r23
	lsr		r7
	ror		r6
	ror		r5
	ror		r4
	dec		r24
	breq	mul_end
prigok2:
	sbrs	r4, 0				; ,   0 
	rjmp	mul_cikl
	add		r8, r16
	adc		r9, r17
	adc		r10, r18
	adc		r11, r19
	adc		r12, r20
	adc		r13, r21
	adc		r14, r22
	adc		r15, r23
	rjmp	mul_cikl
mul_end:
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17
	pop		r16
	pop		r7
	pop		r6
	pop		r5
	pop		r4
	ret

;--------------- ------------------------

;	r4 - Low1	
;	r5 - Low2	
;	r6 - High1	
;	r7 - High2	

;	r8 - Low1	 / 
;	r9 - Low2	 / 
;	r10 - High1	 / 
;	r11 - High2	 / 
;	r12 - Low3	 / 
;	r13 - Low4	 / 
;	r14 - High3	 / 
;	r15 - High4	 / 

delenie:
	push	r0
	push	r30
	push	r2
	push	r25
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	r23
	push	r24
	cp		r4, r0
	cpc		r5, r0
	cpc		r6, r0
	cpc		r7, r0
	brne	del_ne_nol
	inc		r4
del_ne_nol:
	ldi		r24, 0
	mov		r0, r24
	mov		r30, r24
	mov		r2, r24
	mov		r25, r24
	ldi		r16, 0
	ldi		r17, 0
	ldi		r18, 0
	ldi		r19, 0
	ldi		r20, 0
	ldi		r21, 0
	ldi		r22, 0
	ldi		r23, 0
	ldi		r24, 32
	rjmp	propysk
sdvig:
	lsl		r4
	rol		r5
	rol		r6
	rol		r7
propysk:
	inc		r24
	sbrs	r7, 7				; ,   7 
	rjmp	sdvig
sub_go:
	cp		r8, r0
	cpc		r9, r30
	cpc		r10, r2
	cpc		r11, r25
	cpc		r12, r4
	cpc		r13, r5
	cpc		r14, r6
	cpc		r15, r7
	brlo	menshe
	sub		r8, r0
	sbc		r9, r30
	sbc		r10, r2
	sbc		r11, r25
	sbc		r12, r4
	sbc		r13, r5
	sbc		r14, r6
	sbc		r15, r7
	sec
	rjmp	odin
menshe:
	clc
odin:
	rol		r16
	rol		r17
	rol		r18
	rol		r19
	rol		r20
	rol		r21
	rol		r22
	rol		r23
	lsr		r7
	ror		r6
	ror		r5
	ror		r4
	ror		r25
	ror		r2
	ror		r30
	ror		r0
	dec		r24
	brne	sub_go
	mov		r8, r16
	mov		r9, r17
	mov		r10, r18
	mov		r11, r19
	mov		r12, r20
	mov		r13, r21
	mov		r14, r22
	mov		r15, r23
	pop		r24
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	pop		r19
	pop		r18
	pop		r17
	pop		r16
	pop		r25
	pop		r2
	pop		r30
	pop		r0
	ret

;------------------  ------------------

Battery:
	ldi		r24, 0b10000011		; X
	rcall	SPI_Write_CMD
	ldi		r24, 0b01000111		; Y
	rcall	SPI_Write_CMD
	sbi		PORTD,DDD7			;  D/C DATA
	ldi		r23, 18
cikl_shtriha:
	ldi		r24, 0b10000001
	dec		r16
	brne	ne_shtrih
	ldi		r24, 0b10111101
	ldi		r16, 1
ne_shtrih:
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	dec		r23
	brne	cikl_shtriha
	ret

;------------------ ------------------

;	r16 - Low 
;	r17 - High 
;	r19 - X
;	r20 - Y
chislo_XXX:
	ldi		r18, 100
	rcall	perebor_mini
	ldi		r18, 10
	ldi		r24, 7
	add		r19, r24
	rcall	perebor_mini
	ldi		r18, 1
	ldi		r24, 5
	add		r19, r24
	rcall	perebor_mini
	ret

perebor_mini:
	ldi		r30, low(MINI_CIFRA_0*2)
	ldi		r31, high(MINI_CIFRA_0*2)
	rjmp	prig_perebor_mini
ne_menshe_100_mini:
	adiw	r30, 8
	sub		r16, r18
	sbc		r17, r0
prig_perebor_mini:
	cp		r16, r18
	cpc		r17, r0
	brsh	ne_menshe_100_mini
	rcall	IMAGE
	ret

;------------------ 2  7  ------------------

;	r16 - 
;	r19 - X
;	r20 - Y
chislo_XX:
	push	r15
	ldi		r17, 0
	ldi		r18, 0
	ldi		r25, 0xFF
	mov		r15, r25
	rjmp	na_XX

;	r16 -  
;	r17 -  
;	r18 -  
;	r19 - X
;	r20 - Y
;	r21 - 

chislo_XXXXXXX:
	push	r15
	mov		r15, r21
	ldi		r25, 0
	ldi		r21, 0x80
	ldi		r22, 0x96
	ldi		r23, 0x98
	cp		r16, r21
	cpc		r17, r22
	cpc		r18, r23
	brlo	vse_ok
	ldi		r16, 0x7F
	ldi		r17, 0x96
	ldi		r18, 0x98
vse_ok:
	ldi		r21, 0x40
	ldi		r22, 0x42
	ldi		r23, 0x0F
	rcall	perebor
	ldi		r21, 0xA0
	ldi		r22, 0x86
	ldi		r23, 0x01
	rcall	perebor
	ldi		r21, low(10000)
	ldi		r22, high(10000)
	ldi		r23, 0
	rcall	perebor
	ldi		r21, low(1000)
	ldi		r22, high(1000)
	ldi		r23, 0
	rcall	perebor
	ldi		r21, 100
	ldi		r22, 0
	ldi		r23, 0
	rcall	perebor
na_XX:
	ldi		r21, 10
	ldi		r22, 0
	ldi		r23, 0
	rcall	perebor
	ldi		r21, 1
	ldi		r22, 0
	ldi		r23, 0
	ldi		r25, 0xFF
	rcall	perebor
	pop		r15
	ret

perebor:
	dec		r15
	brne	ne_zapitay_0
	ldi		r25, 0xFF
ne_zapitay_0:
	ldi		r30, low(CIFRA_0*2)
	ldi		r31, high(CIFRA_0*2)
	rjmp	prig_perebor
ne_menshe_100:
	ldi		r25, 0xFF
	adiw	r30, 18
	sub		r16, r21
	sbc		r17, r22
	sbc		r18, r23
prig_perebor:
	cp		r16, r21
	cpc		r17, r22
	cpc		r18, r23
	brsh	ne_menshe_100
	cpi		r25, 0
	brne	ne_zatirka_cifr
	ldi		r30, low(ne_CIFRA*2)
	ldi		r31, high(ne_CIFRA*2)
ne_zatirka_cifr:
	rcall	IMAGE
	ldi		r24, 8
	cp		r15, r0
	brne	ne_zapitay_1
	ldi		r30, low(ZAPITAY*2)
	ldi		r31, high(ZAPITAY*2)
	add		r19, r24
	rcall	IMAGE
	ldi		r24, 4
ne_zapitay_1:
	add		r19, r24
	ret

;------------------ ----------------------

IMAGE:
	push	r20
	push	r21
	push	r22
	push	r23
	lpm		r21, Z+				;  X
	lpm		r22, Z+				;  Y
	ori		r19, 0b10000000		; X
	ldi		r24, 0b01000111
	sub		r24, r20
	mov		r20, r24			; Y
cikle_imageY:
	cbi		PORTD,DDD7			;   D/C CMD
	out		SPDR, r19			; X
	rcall	clk_18
	in		r24, SPSR
	out		SPDR, r20			; Y
	rcall	clk_18
	in		r24, SPSR
	dec		r20
	sbrs	r20, 6
	ldi		r20, 0b01000000
	mov		r23, r21
	sbi		PORTD,DDD7			;  D/C DATA
	ldi		r24, 0b01110000
	out		SPCR, r24
cikle_imageX:
	lpm		r24, Z+
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	dec		r23
	brne	cikle_imageX
	ldi		r24, 0b01010000
	out		SPCR, r24
	dec		r22
	brne	cikle_imageY
	pop		r23
	pop		r22
	pop		r21
	pop		r20
	ret

;------------------------  ----------------------

ZASTAVKA:
	ldi		r16, 1
	ldi		r17, 0
zastava:
	ldi		r30, low(RAD_BIG*2)
	ldi		r31, high(RAD_BIG*2)
	ldi		r20, 0b01001000		; Y
	ldi		r21, 9
cikle_zasY:
	cbi		PORTD,DDD7			;   D/C CMD
	ldi		r24, 0b10000000		; X
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	out		SPDR, r20			; Y
	rcall	clk_18
	in		r24, SPSR
	dec		r20
	sbi		PORTD,DDD7			;  D/C DATA
	ldi		r24, 0b01110000
	out		SPCR, r24
	ldi		r22, 96
cikle_zasX:
	lpm		r24, Z+
	lsr		r16
	rol		r17
	eor		r16, r17
	or		r24, r16
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	dec		r22
	brne	cikle_zasX
	ldi		r24, 0b01010000
	out		SPCR, r24
	dec		r21
	brne	cikle_zasY
	dec		r18
	brne	zastava
	ret

shym:
	ldi		r16, 1
	ldi		r17, 0
cikl_slychaino:
	ldi		r30, low(1000)
	ldi		r31, high(1000)
slychaino:
	lsr		r16
	rol		r17
	eor		r16, r17
	mov		r24, r16
	rcall	SPI_Write_DATA
	sbiw	r30, 1
	brne	slychaino
	dec		r18
	brne	cikl_slychaino
	ret

Zabelenie:
	ldi		r24, 0b10000000		; X
	rcall	SPI_Write_CMD
	ldi		r24, 0b01001000		; Y
	rcall	SPI_Write_CMD
	sbi		PORTD,DDD7			;  D/C DATA
	ldi		r22, 9
cikl_belizni_Y:
	ldi		r23, 102
cikl_belizni_X:
	out		SPDR, r0
	rcall	clk_18
	in		r24, SPSR
	dec		r23
	brne	cikl_belizni_X
	dec		r22
	brne	cikl_belizni_Y
	ret

;-------------------- ----------------------

LCD_init:
	cbi		PORTD,DDD5			;   RES
	ldi		r23, 10
	rcall	pause
	sbi		PORTD,DDD5			;  RES
	ldi		r23, 1
	rcall	pause
	ldi		r24,0b00100001		; H=1
	rcall	SPI_Write_CMD
	ldi		r24,0b11111111		; Vop (Low)
	rcall	SPI_Write_CMD
	ldi		r24,0b00010011		; Bias
	rcall	SPI_Write_CMD
	ldi		r24,0b00001011		; 5x voltage multiplier
	rcall	SPI_Write_CMD
	ldi		r24,0b00000111		; temperature coef?cient
	rcall	SPI_Write_CMD

	ldi		r24,0b00100000		; H=0
	rcall	SPI_Write_CMD
	ldi		r24,0b00010001		; PRS=1

	rcall	SPI_Write_CMD
	ldi		r24,0b00100001		; H=1
	rcall	SPI_Write_CMD
	ldi		r24,0b11011111		; Vop (High)
	rcall	SPI_Write_CMD

	ldi		r24,0b00100000		; H=0, mirror on horizontally
	rcall	SPI_Write_CMD
	ldi		r24,0b00001100		; D=1 E=0 - normal mode
	rcall	SPI_Write_CMD
	ret

;------------------------SPI------------------------

SPI_init:
	ldi		r24, 0b01010000		; Master Mode(MSTR), Enable SPI(SPE)
	out		SPCR, r24
;	mov		r2, r24
	ldi		r24, 0b00000001		; double speed bit(SPI2X)
	out		SPSR, r24
	ret

;------------------   SPI----------------------

; r24- 

SPI_Write_CMD:
	cbi		PORTD,DDD7			;   D/C CMD
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	ret

SPI_Write_DATA:
;	cbi		PORTD,DDD7			;   D/C CMD
	sbi		PORTD,DDD7			;  D/C DATA
	out		SPDR, r24
	rcall	clk_18
	in		r24, SPSR
	ret

clk_18:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ret

;-------------------- ----------------------

ADC7_start:
	sbi		DDRC, DDC1
	sbi		DDRC, DDC0
	ldi		r24, 0b11000111		; ADC7 1.1V ADLAR = 0
	sts		ADMUX, r24
	ldi		r24, 0b11000100		; 62,5 kHz	 
	sts		ADCSRA, r24
	ret

ADC7_stop:
	cbi		DDRC, DDC1
	cbi		DDRC, DDC0
	sts		ADMUX, r0
	sts		ADCSRA, r0
	ret

opros_ADIF1:
	lds		r24, ADCSRA
	sbrs	r24, 4				; ,   ADIF ,  
	rjmp	opros_ADIF1
	ret

;-------------------- INT----------------------

INT_init:
	ldi		r24, 0b00001010
	sts		EICRA, r24
	ldi		r24, 0b00000011
	out		EIMSK, r24
	ret

;-------------------- ----------------------

timer_init:
	ldi		r24, high(500)
	sts		OCR1AH, r24
	sts		OCR1BH, r24
	ldi		r24, low(500)
	sts		OCR1AL, r24
	sts		OCR1BL, r24

	ldi		r24, 0b00001001		; CTC and clk/1
	sts		TCCR1B, r24
	ldi		r24, 0b00000100		; OCIE1B
	sts		TIMSK1, r24
;	sei

reset_timer:
;	ldi		r24, 0
	sts		TCNT1H, r0
	sts		TCNT1L, r0

	ret

;------------------ ------------------

Global_Obnulenie:
	cli
	ldi		r24, low(2000)
	ldi		r25, high(2000)
	sts		Time2000_low, r24
	sts		Time2000_high, r25
	sts		Time_low, r0
	sts		Time_high, r0
	sts		Time_syper_high, r0
	sts		SECUNDS, r0
	sts		MINUTES, r0
	sts		HOURS, r0
	ldi		r24, low(500)
	ldi		r25, high(500)
	sts		Anim_low, r24
	sts		Anim_high, r25
;	sts		Anim, r0
	ldi		r26, 0
	ldi		r27, 0
	ldi		r28, 0
	ldi		r29, 0

	ldi		r30, low(Do_r26)
	ldi		r31, high(Do_r26)
	ldi		r24, 81
cikl_zanuleniy:
	st		Z+, r0
	dec		r24
	brne	cikl_zanuleniy

;	sei
	reti

;------------------ ~0,01 ------------------

pause:
	push	r24
	push	r25
cikl_pause_10ms:
	ldi		r24, low(2500)
	ldi		r25, high(2500)
cikl_pause_t:
	sbiw	r24, 1
	brne	cikl_pause_t
	dec		r23
	brne	cikl_pause_10ms
	pop		r25
	pop		r24
	ret

;----------------------------------DATA----------------------------------

MINI_CIFRA_0:
.db 5, 1
.db 0x00,0x7C,0x82,0x82,0x7C,0x00

MINI_CIFRA_1:
.db 5, 1
.db 0x00,0x08,0x04,0xFE,0x00,0x00

MINI_CIFRA_2:
.db 5, 1
.db 0x00,0xC4,0xA2,0x92,0x8C,0x00

MINI_CIFRA_3:
.db 5, 1
.db 0x00,0x44,0x82,0x92,0x6C,0x00

MINI_CIFRA_4:
.db 5, 1
.db 0x00,0x30,0x28,0x24,0xFE,0x00

MINI_CIFRA_5:
.db 5, 1
.db 0x00,0x4E,0x8A,0x8A,0x72,0x00

MINI_CIFRA_6:
.db 5, 1
.db 0x00,0x7C,0x92,0x92,0x64,0x00

MINI_CIFRA_7:
.db 5, 1
.db 0x00,0x02,0xC2,0x3A,0x06,0x00

MINI_CIFRA_8:
.db 5, 1
.db 0x00,0x6C,0x92,0x92,0x6C,0x00

MINI_CIFRA_9:
.db 5, 1
.db 0x00,0x4C,0x92,0x92,0x7C,0x00

ne_CIFRA:
.db	8, 2
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

CIFRA_0:
.db	8, 2
.db 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE, 0xFC, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60, 0x7F, 0x3F, 0x00

CIFRA_1:
.db	8, 2
.db 0x00, 0x18, 0x1C, 0xFE, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x7F, 0x7F, 0x60, 0x60, 0x00

CIFRA_2:
.db	8, 2
.db 0x00, 0x06, 0x86, 0x86, 0x86, 0xFE, 0xFC, 0x00, 0x00, 0x7F, 0x7F, 0x61, 0x61, 0x61, 0x60, 0x00

CIFRA_3:
.db	8, 2
.db 0x00, 0x06, 0x86, 0x86, 0x86, 0xFE, 0x7C, 0x00, 0x00, 0x60, 0x61, 0x61, 0x61, 0x7F, 0x3E, 0x00

CIFRA_4:
.db	8, 2
.db 0x00, 0xFE, 0xFE, 0x80, 0x80, 0xFE, 0xFE, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x7F, 0x7F, 0x00

CIFRA_5:
.db	8, 2
.db 0x00, 0xFE, 0xFE, 0x86, 0x86, 0x86, 0x06, 0x00, 0x00, 0x61, 0x61, 0x61, 0x61, 0x7F, 0x3F, 0x00

CIFRA_6:
.db	8, 2
.db 0x00, 0xFC, 0xFE, 0x86, 0x86, 0x8E, 0x0C, 0x00, 0x00, 0x3F, 0x7F, 0x61, 0x61, 0x7F, 0x3F, 0x00

CIFRA_7:
.db	8, 2
.db 0x00, 0x06, 0x06, 0x06, 0x06, 0xFE, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x7F, 0x00

CIFRA_8:
.db	8, 2
.db 0x00, 0x7C, 0xFE, 0x86, 0x86, 0xFE, 0x7C, 0x00, 0x00, 0x3E, 0x7F, 0x61, 0x61, 0x7F, 0x3E, 0x00

CIFRA_9:
.db	8, 2
.db 0x00, 0x7C, 0xFE, 0x86, 0x86, 0xFE, 0xFC, 0x00, 0x00, 0x30, 0x71, 0x61, 0x61, 0x7F, 0x3F, 0x00

ZAPITAY:
.db	4, 2
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x60, 0x00

RAD_BIG:
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x7F
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xF8
.db 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0
.db 0xF8, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF8, 0xFC, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF8, 0xFE, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xFC, 0xF8, 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0xC0, 0xF8, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x7E, 0x38, 0x00, 0x80, 0x80, 0x80, 0xC0, 0xC0
.db 0xC0, 0xC0, 0x80, 0x80, 0x80, 0x00, 0x38, 0x7E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF8, 0xC0, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F
.db 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x03, 0x00, 0x70, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x70, 0x00, 0x03, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F
.db 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x87, 0x8F, 0x8F, 0x8F, 0x1F, 0x1F
.db 0x1F, 0x1F, 0x8F, 0x8F, 0x8F, 0x87, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF8, 0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0xF8, 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x80, 0xC0, 0xF0, 0xFC, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0xF0, 0xC0, 0x80, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x01, 0x03, 0x03, 0x07, 0x07, 0x07, 0x0F, 0x0F, 0x0F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F
.db 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x0F, 0x0F, 0x0F, 0x07, 0x07, 0x07, 0x03, 0x03, 0x01, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

RAD_0:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x60, 0x78, 0x7C, 0x7E, 0x7F, 0x7C, 0xB0, 0xC0, 0xE0, 0xC0, 0xB0, 0x7C, 0x7F
.db 0x7E, 0x7C, 0x78, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x70, 0xFD, 0xFF, 0xFD
.db 0x70, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

RAD_1:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0xE0, 0xF0, 0xE0, 0xE0, 0xC0, 0xC0, 0x80, 0xC0, 0xE0, 0xDF, 0xBF, 0x3F, 0x1F
.db 0x1E, 0x0C, 0x08, 0x00, 0x00, 0x00, 0x03, 0x07, 0x03, 0x03, 0x01, 0x01, 0x00, 0x01, 0x03, 0xFD
.db 0xFE, 0x7E, 0x7C, 0x3C, 0x18, 0x08, 0x00, 0x00, 0x00, 0x00

RAD_2:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x87, 0xDF, 0xFF, 0xDF, 0x87, 0x01, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x0F, 0x1F, 0x3F, 0x7F, 0x1F, 0x06, 0x01, 0x03, 0x01
.db 0x06, 0x1F, 0x7F, 0x3F, 0x1F, 0x0F, 0x03, 0x00, 0x00, 0x00

RAD_3:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x08, 0x0C, 0x1E, 0x1F, 0x3F, 0xBF, 0xDF, 0xE0, 0xC0, 0x80, 0xC0, 0xC0
.db 0xE0, 0xE0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x08, 0x18, 0x3C, 0x7C, 0x7E, 0xFE, 0xFD, 0x03, 0x01
.db 0x00, 0x01, 0x01, 0x03, 0x03, 0x07, 0x03, 0x00, 0x00, 0x00

RODGER:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0xE6, 0x66, 0xFE, 0x66, 0xE6, 0x3C
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0x63, 0x24, 0x15, 0x18, 0x09
.db 0x18, 0x15, 0x24, 0x63, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00

RODGER_inv:
.db 19, 3
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC3, 0x19, 0x99, 0x01, 0x99, 0x19, 0xC3
.db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xDD, 0x9C, 0xDB, 0xEA, 0xE7, 0xF6
.db 0xE7, 0xEA, 0xDB, 0x9C, 0xDD, 0xFF, 0xFF, 0xFF, 0xFF, 0x00

PAUSA:
.db 14, 2
.db 0x00, 0x00, 0x00, 0xF8, 0x08, 0xF8, 0x00, 0xF8, 0x08, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x1F, 0x10, 0x1F, 0x00, 0x1F, 0x10, 0x1F, 0x00, 0x00, 0x00, 0x00

PLAV:
.db 14, 2
.db 0x00, 0x00, 0x40, 0x20, 0x10, 0x10, 0x20, 0x40, 0x80, 0x80, 0x40, 0x20, 0x00, 0x00, 0x00, 0x00
.db 0x04, 0x02, 0x01, 0x01, 0x02, 0x04, 0x08, 0x08, 0x04, 0x02, 0x00, 0x00

SUMMA:
.db 14, 2
.db 0x00, 0x00, 0x10, 0x30, 0x50, 0x90, 0x10, 0x10, 0x10, 0x10, 0x10, 0x30, 0x00, 0x00, 0x00, 0x00
.db 0x40, 0x60, 0x50, 0x48, 0x45, 0x42, 0x40, 0x40, 0x40, 0x60, 0x00, 0x00

CPS:
.db 14, 1
.db 0x3E, 0x41, 0x41, 0x22, 0x00, 0x7F, 0x09, 0x09, 0x06, 0x00, 0x26, 0x49, 0x49, 0x32

MkrH:
.db 25, 1
.db 0x04, 0x78, 0x04, 0x78, 0x04, 0x78, 0x00, 0x7F, 0x10, 0x28, 0x44, 0x00, 0x7F, 0x09, 0x09, 0x76
.db 0x00, 0x60, 0x1C, 0x03, 0x00, 0x7F, 0x08, 0x04, 0x78, 0x00

Batter:
.db 81, 2
.db 0x3C, 0xE7, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81
.db 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xFF, 0x00, 0x00, 0x00, 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE
.db 0xFC, 0x00, 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE, 0xFC, 0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0xFC
.db 0xFE, 0x06, 0x06, 0xFE, 0xFC, 0x00, 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE, 0xFC, 0x00, 0x00, 0x60
.db 0x60, 0x00, 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE, 0xFC, 0x00, 0x00, 0xFC, 0xFE, 0x06, 0x06, 0xFE
.db 0xFC, 0x00, 0x7C, 0x82, 0x82, 0x7C, 0x00, 0x80, 0x00, 0x7C, 0x82, 0x82, 0x7C, 0x00, 0x7C, 0x82
.db 0x82, 0x7C, 0x00, 0x0C, 0x30, 0xC0, 0x30, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60
.db 0x7F, 0x3F, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60, 0x7F, 0x3F, 0x00, 0x00, 0x06, 0x06, 0x00, 0x00
.db 0x3F, 0x7F, 0x60, 0x60, 0x7F, 0x3F, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60, 0x7F, 0x3F, 0x00, 0x00
.db 0x06, 0x06, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60, 0x7F, 0x3F, 0x00, 0x00, 0x3F, 0x7F, 0x60, 0x60
.db 0x7F, 0x3F

Alfa:
.db 16, 2
.db 0xC0, 0xE0, 0x20, 0x60, 0xC0, 0xE0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80
.db 0x07, 0x0F, 0x08, 0x0C, 0x07, 0x0F, 0x0C, 0x04, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x02, 0x02

Beta:
.db 16, 2
.db 0x00, 0xF8, 0xFC, 0x46, 0x66, 0xFC, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80
.db 0x00, 0xFF, 0x7F, 0x08, 0x18, 0x0C, 0x0F, 0x03, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x02, 0x02

Gamma:
.db 16, 2
.db 0x60, 0x30, 0x70, 0xE0, 0x80, 0xE0, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80
.db 0x00, 0x00, 0x00, 0x7F, 0x3F, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x02, 0x02

Summa_ravno:
.db 16, 2
.db 0x18, 0x38, 0x78, 0xF8, 0xD8, 0x98, 0x18, 0x38, 0x38, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80
.db 0x30, 0x38, 0x3C, 0x3E, 0x37, 0x33, 0x31, 0x38, 0x38, 0x00, 0x00, 0x00, 0x02, 0x02, 0x02, 0x02

Result:
.db 73, 2
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0xF0, 0x20, 0x10, 0x10, 0x00, 0xE0, 0x90, 0x90, 0x90, 0xE0, 0x00, 0x60, 0x90, 0x90
.db 0x90, 0x20, 0x00, 0xF0, 0x00, 0x00, 0x00, 0xF0, 0x00, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10
.db 0xF0, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00
.db 0x03, 0x04, 0x04, 0x04, 0x00, 0x00, 0x02, 0x04, 0x04, 0x04, 0x03, 0x00, 0x03, 0x04, 0x04, 0x04
.db 0x03, 0x00, 0x07, 0x04, 0x04, 0x04, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
.db 0x00, 0x00
